import java.awt.Checkbox;
import java.awt.Font;
import java.awt.Frame;
import java.awt.Panel;
import java.awt.Label;
import java.awt.TextField;

import java.awt.Button;

/**
 * PDPSniff - PDPClient2.java
 * 
 * Jos Carlos Perea Barreiro (jperea[at]it.uc3m.es) Created
 * on 22-may-2005
 *  
 */

/**
 * @author Jose Carlos
 * 
 * TODO To change the template for this generated type
 * comment go to Window - Preferences - Java - Code Style -
 * Code Templates
 */
public class Configuration extends Panel
{
    private PDPClient p = null;
    
	private Checkbox	c0		= null;
	private Checkbox	c1		= null;
	private Checkbox	c2		= null;
	private TextField	t0		= null;
	private TextField	t1		= null;
	private TextField	t2		= null;

	private Button		button	= null;
	private Button		button1	= null;

	private Label label = null;
	private void reset ( )
	{
		c0.setState ( true );
		c1.setState ( true );
		c2.setState ( true );

		t0.setText ( "5" );
		t1.setText ( "5" );
		t2.setText ( "10" );

	}

	private void accept ( ) throws Exception
	{
		String aa, bb, cc;
		aa = t0.getText ( );
		bb = t1.getText ( );
		cc = t2.getText ( );
		if ( aa.equals ( "" ) )
		{
			throw new Exception ( "Please fill the local cache size field" );
		}
		if ( bb.equals ( "" ) )
		{
			throw new Exception ( "Please fill the remote cache size field" );
		}
		if ( cc.equals ( "" ) )
		{
			throw new Exception ( "Please fill the availability time field" );
		}
		int a, b, c;
		try
		{
			a = Integer.parseInt ( aa );
			b = Integer.parseInt ( bb );
			c = Integer.parseInt ( cc );
		}
		catch ( Exception e )
		{
			throw new Exception ( "Please insert correct values" );
		}
        
        if ( a < 0 || b < 0 || c <= 0 )
            throw new Exception ( "Please use positive values" );
        
        p.setConf ( c0.getState(), c1.getState(), c2.getState(), a, b, c*60 );
        p.swap(PDPClient.LOCALCACHE);
	}

	public static void main ( String args[] )
	{
        Frame f = new Frame ( );
        f.setSize ( 245, 300 );
        f.add ( new Configuration ( null ) );
        f.setVisible ( true );
	}

	/**
	 * This is the default constructor
	 */
	public Configuration ( PDPClient p)
	{
		super ( );

        this.p = p;
		initialize ( );
		reset ( );
	}

	/**
	 * This method initializes this
	 * 
	 * @return void
	 */
	private void initialize ( )
	{
		label = new Label();
		this.setLayout ( null );
		this.setSize ( 240, 270 );
		this.setFont ( new Font ( "", Font.PLAIN, 10 ) );

        Label status = new Label ( );
		Label label0 = new Label ( );
		Label label1 = new Label ( );
		Label label2 = new Label ( );
		Label label3 = new Label ( );
		Label label4 = new Label ( );
		Label label5 = new Label ( );
		Label label6 = new Label ( );

        status.setText ( "Pervasive Discovery Protocol. 2005 (c)" );
        status.setLocation ( 0, 255 );
        status.setSize (240, 15);
        this.add ( status, null );
        
        label0.setText ( "PDP CONFIGURATION" );
        label0.setLocation ( 5, 5 );
        label0.setSize (186, 15);
        label0.setFont ( new Font ( "", Font.BOLD, 12 ) );
        this.add ( label0, null );

		label1.setText ( "Enable user agent" );
		label1.setLocation (41, 40);
		label1.setSize ( 110, 16 );
		this.add ( label1, null );

		label2.setText ( "Enable service agent" );
		label2.setLocation (41, 60);
		label2.setSize ( 110, 15 );
		this.add ( label2, null );

		label3.setText ( "Enable deregister" );
		label3.setLocation (41, 80);
		label3.setSize ( 110, 15 );
		this.add ( label3, null );

		label4.setText ( "Local cache size (#services)" );
		label4.setLocation (26, 104);
		label4.setSize ( 145, 15 );
		this.add ( label4, null );

		label5.setText ( "Remote cache size (#services)" );
		label5.setLocation (26, 124);
		label5.setSize ( 145, 15 );
		this.add ( label5, null );

		label6.setText ( "Availability time (in minutes)" );
		label6.setLocation (26, 144);
		label6.setSize ( 145, 15 );
		this.add ( label6, null );
		this.add ( getButton ( ), null );
		this.add ( getButton1 ( ), null );

        c0 = new Checkbox ( );
        c1 = new Checkbox ( );
        c2 = new Checkbox ( );
       
		c0.setLocation (25, 40);
		c0.setSize ( 15, 15 );

		c1.setLocation (25, 60);
		c1.setSize ( 15, 15 );

		c2.setLocation (25, 80);
		c2.setSize ( 15, 15 );

		this.add ( c0, null );
		this.add ( c1, null );
		this.add ( c2, null );

        t0 = new TextField ( );
        t1 = new TextField ( );
        t2 = new TextField ( );
        
		t0.setLocation (176, 104);
		t0.setSize ( 30, 15 );

		t1.setLocation (176, 124);
		t1.setSize ( 30, 15 );

		t2.setLocation (176, 144);
		t2.setSize ( 30, 15 );

		label.setBounds(20, 214, 205, 21);
		label.setText("");
		label.setAlignment(Label.CENTER);
        
		this.add ( t0, null );
		this.add ( t1, null );
		this.add ( t2, null );
		this.add(label, null);
	}

	/**
	 * This method initializes button
	 * 
	 * @return java.awt.Button
	 */
	private Button getButton ( )
	{
		if ( button == null )
		{
			button = new Button ( );
			button.setSize ( 60, 16 );
			button.setLocation (41, 174);
			button.setLabel ( "Accept" );
			button.addActionListener ( new java.awt.event.ActionListener ( ) {
				public void actionPerformed ( java.awt.event.ActionEvent e )
				{
					try
					{
						accept ( );
					}
					catch ( Exception ex )
					{
						label.setText( ex.getMessage() );
					}
				}
			} );
		}
		return button;
	}

	/**
	 * This method initializes button1
	 * 
	 * @return java.awt.Button
	 */
	private Button getButton1 ( )
	{
		if ( button1 == null )
		{
			button1 = new Button ( );
			button1.setLabel ( "Reset" );
			button1.setLocation (111, 174);
			button1.setSize ( 60, 16 );
			button1.addActionListener ( new java.awt.event.ActionListener ( ) {
				public void actionPerformed ( java.awt.event.ActionEvent e )
				{
					reset ( );
				}
			} );
		}
		return button1;
	}
}  //  @jve:decl-index=0:visual-constraint="233,178"