
import java.awt.Font;
import java.awt.Frame;
import java.awt.Panel;
import java.awt.Label;
import java.awt.TextField;

import java.awt.Button;

import java.awt.List;

/**
 * PDPSniff - LocalCache2.java
 * 
 * Jos Carlos Perea Barreiro (jperea[at]it.uc3m.es) Created
 * on 22-may-2005
 *  
 */

/**
 * @author Jose Carlos
 * 
 * TODO To change the template for this generated type
 * comment go to Window - Preferences - Java - Code Style -
 * Code Templates
 */
public class LocalCache extends Panel
{
	private PDPClient	p		= null;
	private int			MAX_SIZE;
	private int			ttl;
	private int			count;

    private Label label = null;
    
	private TextField	t0		= null;
	private TextField	t1		= null;
	private TextField	t2		= null;

	private Button		acceptb	= null;
	private Button		deleteb	= null;
	private Button		finishb	= null;

	private List		list	= null;

	public static void main ( String args[] )
	{
		Frame f = new Frame ( );
		f.setSize ( 250, 300 );
		f.add ( new LocalCache ( null, 5, 5 ) );
		f.setVisible ( true );
	}

	private void add ( ) throws Exception
	{
		if ( count == MAX_SIZE )
		{
			throw new Exception ( "Local cache full" );
		}
		String aa = t0.getText ( );
		String bb = t1.getText ( );
		String cc = t2.getText ( );

		if ( aa.equals ( "" ) )
		{
			throw new Exception ( "Please fill the service type field" );
		}
		if ( bb.equals ( "" ) )
		{
			throw new Exception ( "Please fill the URL field" );
		}
		if ( cc.equals ( "" ) )
		{
			throw new Exception ( "Please fill the TTL field" );
		}

		int a;

		try
		{
			a = Integer.parseInt ( cc );
		}
		catch ( Exception e )
		{
			throw new Exception ( "Please insert a correct TTL value" );
		}

		if ( p.pdp.addLocal ( aa, bb, a ) )
		{
            count++;
            finishb.setEnabled ( true );
            list.add ( a + " @ service:" + aa + "://" + bb );
		}
        else
        {
        	throw new Exception ( "Service stored yet" );
        }
	}

	private void reset ( )
	{
		t0.setText ( "" );
		t1.setText ( "" );
		t2.setText ( "" + ttl );
        label.setText("");
	}

	/**
	 * This method initializes button
	 * 
	 * @return java.awt.Button
	 */
	private Button getAcceptp ( )
	{
		if ( acceptb == null )
		{
			acceptb = new Button ( );
			acceptb.setBounds ( 25, 95, 60, 17 );
			acceptb.setLabel ( "Add" );
			acceptb.addActionListener ( new java.awt.event.ActionListener ( ) {
				public void actionPerformed ( java.awt.event.ActionEvent e )
				{
					boolean f = finishb.isEnabled ( );
					try
					{
						t0.setEnabled ( false );
						t1.setEnabled ( false );
						t2.setEnabled ( false );
						acceptb.setEnabled ( false );
						deleteb.setEnabled ( false );
						finishb.setEnabled ( false );
						add ( );
						f = true;
					}
					catch ( Exception ex )
					{
						label.setText( ex.getMessage() );
					}
					if ( count == MAX_SIZE )
					{
						acceptb.setEnabled ( false );
						deleteb.setEnabled ( false );
					}
					else
					{
						acceptb.setEnabled ( true );
						deleteb.setEnabled ( true );
					}
					t0.setEnabled ( true );
					t1.setEnabled ( true );
					t2.setEnabled ( true );
					finishb.setEnabled ( f );

				}
			} );
		}
		return acceptb;
	}

	/**
	 * This method initializes button1
	 * 
	 * @return java.awt.Button
	 */
	private Button getDeleteb ( )
	{
		if ( deleteb == null )
		{
			deleteb = new Button ( );
			deleteb.setBounds ( 90, 95, 60, 17 );
			deleteb.setLabel ( "Clear" );
			deleteb.addActionListener ( new java.awt.event.ActionListener ( ) {
				public void actionPerformed ( java.awt.event.ActionEvent e )
				{
					reset ( );
				}
			} );
		}
		return deleteb;
	}

	/**
	 * This method initializes button2
	 * 
	 * @return java.awt.Button
	 */
	private Button getFinishb ( )
	{
		if ( finishb == null )
		{
			finishb = new Button ( );
			finishb.setBounds ( 155, 95, 60, 17 );
			finishb.setLabel ( "Done" );
			finishb.setEnabled ( false );
			finishb.addActionListener ( new java.awt.event.ActionListener ( ) {
				public void actionPerformed ( java.awt.event.ActionEvent e )
				{
					p.swap ( PDPClient.SEARCH );
				}
			} );
		}
		return finishb;
	}

	/**
	 * This method initializes list
	 * 
	 * @return java.awt.List
	 */
	private List getList ( )
	{
		if ( list == null )
		{
			list = new List ( MAX_SIZE );
			list.setBounds ( 10, 140, 220, 115 );
			list.setMultipleMode ( false );
		}
		return list;
	}

	/**
	 * This is the default constructor
	 */
	public LocalCache ( PDPClient p, int max_size, int ttl )
	{
		super ( );
		this.MAX_SIZE = max_size;
		this.count = 0;
		this.p = p;
		this.ttl = ttl;
		initialize ( );
		reset ( );
	}

	/**
	 * This method initializes this
	 * 
	 * @return void
	 */
	private void initialize ( )
	{
		Label l0 = new Label ( );
		Label l1 = new Label ( );
		Label l2 = new Label ( );
		Label l3 = new Label ( );
		Label status = new Label ( );
        label = new Label ( );
        
		this.setLayout ( null );
		this.setSize ( 240, 270 );
		this.setFont ( new Font ( "", Font.PLAIN, 10 ) );

        label.setBounds(17, 116, 205, 21);
        label.setText("");
        label.setAlignment(Label.CENTER);
        this.add ( label, null );
        
		status.setText ( "Pervasive Discovery Protocol. 2005 (c)" );
		status.setLocation ( 0, 255 );
		status.setSize ( 240, 15 );
		this.add ( status, null );

		this.add ( getAcceptp ( ), null );
		this.add ( getDeleteb ( ), null );
		this.add ( getFinishb ( ), null );
		this.add ( getList ( ), null );

		l0.setBounds ( 5, 5, 193, 15 );
		l0.setText ( "LOCAL CACHE CONFIGURATION" );
		l0.setFont ( new Font ( "", Font.BOLD, 12 ) );
		this.add ( l0, null );

		l1.setBounds ( 35, 35, 80, 15 );
		l1.setText ( "Service type" );
		this.add ( l1, null );

		l2.setBounds ( 35, 55, 80, 15 );
		l2.setText ( "URL" );
		this.add ( l2, null );

		l3.setBounds ( 35, 75, 80, 15 );
		l3.setText ( "TTL (seconds)" );
		this.add ( l3, null );

		t0 = new TextField ( );
		t0.setLocation ( 115, 35 );
		t0.setSize ( 90, 16 );
		this.add ( t0, null );

		t1 = new TextField ( );
		t1.setLocation ( 115, 55 );
		t1.setSize ( 90, 16 );
		this.add ( t1, null );

		t2 = new TextField ( );
		t2.setLocation ( 115, 75 );
		t2.setSize ( 90, 16 );
		this.add ( t2, null );
	}
}
