import com.uc3m.it.pfc.pdp.PDP;

import java.awt.Toolkit;
import java.awt.Dimension;
import java.awt.Frame;
import java.awt.Panel;

/**
 * PDPSniff - PDPClient2.java
 * 
 * Jos Carlos Perea Barreiro (jperea[at]it.uc3m.es) Created
 * on 23-may-2005
 *  
 */

/**
 * @author Jose Carlos
 * 
 * TODO To change the template for this generated type
 * comment go to Window - Preferences - Java - Code Style -
 * Code Templates
 */
public class PDPClient extends Frame
{
    private int X_OFFSET;
    private int Y_OFFSET;
    
	public static final byte LICENSE	= 0;
	public static final byte LOCALCACHE	= 1;
	public static final byte SEARCH		= 2;

    private boolean ua;
    private boolean sa;
    private boolean de;
    private int lo;
    private int re;
    private int tm;
    
    protected PDP pdp;
    
    public static void main ( String [] args )
	{
        new PDPClient ( );
	}

	/**
	 * This is the default constructor
	 */
	public PDPClient ( )
	{
		super ( );
        
        int x, y;
        
        Dimension dim = Toolkit.getDefaultToolkit().getScreenSize();
        if ( dim.height < 480 || dim.width < 640 )
        {
            x = 0;
            y = 0;
        }
        else
        {
            x = 5;
            y = 23;
        }
        dim = null;
        
        this.X_OFFSET = x;
        this.Y_OFFSET = y;
		initialize ( );
	}

	/**
	 * This method initializes this
	 * 
	 * @return void
	 */
	private void initialize ( )
	{
		this.setLayout(null);
		this.setSize ( 250, 300 );
		this.setTitle ( "PDP Demo Client v1.1" );
        Panel p = new License ( this );
        p.setLocation ( X_OFFSET, Y_OFFSET );
		this.add ( p );
		this.setVisible ( true );
        
	}

    protected void setConf ( boolean a, boolean b, boolean c, int d, int e, int f )
    {
        this.ua = a;
        this.sa = b;
        this.de = c;
        this.lo = d;
        this.re = e;
        this.tm = f;
    }
    
	protected void swap ( int t )
	{
        Panel p = null;
		switch ( t )
		{
			case LICENSE:
                this.removeAll( );
                p = new Configuration ( this );
                p.setLocation ( X_OFFSET, Y_OFFSET );
                this.add ( p );
				break;
			case LOCALCACHE:
                try
                {
                    pdp = new PDP ( lo, re, tm );
                    pdp.setUA(ua);
                    pdp.setSA(sa);
                    pdp.setDereg(de);

                    if ( lo == 0 ) swap ( SEARCH );
                    else
                    {
                        this.removeAll();
                        p = new LocalCache ( this, lo, tm );
                        p.setLocation ( X_OFFSET, Y_OFFSET );
                        this.add ( p );
                    }
                }
                catch ( Exception e )
                {
                	//System.out.println ( e.getMessage() );
                }
				break;
			case SEARCH:
                this.removeAll();
                p = new SearchServices ( this );
                p.setLocation ( X_OFFSET, Y_OFFSET );
                this.add ( p );
				break;
		}
        this.repaint();
        System.gc ( );
	}
    
    protected void close ( )
    {
        if ( pdp != null ) pdp.byebye();
    	System.exit ( 0 );
        
    }
}
