import java.awt.Checkbox;
import java.awt.Color;
import java.awt.Font;
import java.awt.Frame;
import java.awt.Panel;
import java.awt.Label;

import java.awt.List;

import java.awt.TextField;
import java.awt.Button;
import java.util.Vector;

import com.uc3m.it.pfc.pdp.PDPException;
import com.uc3m.it.pfc.pdp.ServiceEntry;

/**
 * PDPSniff - SearchServices.java
 * 
 * Jos Carlos Perea Barreiro (jperea[at]it.uc3m.es) Created
 * on 22-may-2005
 *  
 */

/**
 * @author Jose Carlos
 *  
 */
public class SearchServices extends Panel
{
	protected PDPClient	p			= null;
	private List			response	= null;
	private List			cache		= null;
	private TextField		type		= null;
	private Checkbox		any			= null;
	private Button			stop		= null;
	private Button			button1		= null;
	private Button			clear		= null;
	private Button			accept		= null;

	private Button			button		= null;
	private Label			led			= null;
    
    private boolean ac, cl, st;

	private void reset ( )
	{
		this.response.removeAll ( );
		this.type.setText ( null );
		this.type.setEnabled ( true );
		this.any.setState ( true );
		this.stop.setEnabled ( false );
		this.clear.setEnabled ( true );
		this.accept.setEnabled ( true );
		this.any.setEnabled ( true );
	}

	private void search ( )
	{
		String stype = type.getText ( ).toLowerCase ( );

		this.response.removeAll ( );

		if ( stype.equals ( "" ) )
		{
			this.response.add ( "Write a service type" );
		}
		else
		{
			if ( stype.equals ( "all" ) )
			{
				this.any.setState ( true );
			}

			this.any.setEnabled ( false );
			this.accept.setEnabled ( false );
			this.clear.setEnabled ( false );
			this.stop.setEnabled ( true );
			this.response.add ( "Searching..." );
			this.type.setEnabled ( false );
			new SearchBG ( this, stype, any.getState() );
		}
	}

	private void set ( String s )
	{
		response.removeAll ( );
		response.add ( s );
	}

	private void stop ( )
	{
		try
		{
			p.pdp.stopUA ( );
			String s = type.getText ( );
			boolean b = any.getState ( );
			type.setText ( s );
			any.setState ( b );
			accept.setEnabled ( true );
			clear.setEnabled ( true );
			stop.setEnabled ( false );
		}
		catch ( PDPException e )
		{
			set ( e.getData ( ) );
		}
	}

	protected void addResponse ( Vector response )
	{
		this.response.removeAll ( );
		if ( response == null )
			this.response.add ( "" );

		else
		{
			int j = response.size ( );
			if ( j == 0 )
			{
				this.response.add ( "NOT FOUND" );
			}
			else
			{

				for ( int i = 0; i < j; i++ )
				{
					ServiceEntry se = ( ServiceEntry ) response.elementAt ( i );
					String de = se.getPDPService ( ).getDescription ( );
					int tm = se.getLifetime ( );
					this.response.add ( tm + " @ " + de );
				}
			}
		}

		this.stop.setEnabled ( false );
		this.accept.setEnabled ( true );
		this.clear.setEnabled ( true );
		this.type.setEnabled ( true );

		refreshCache ( );
	}

	private void refreshCache ( )
	{
		this.cache.removeAll ( );
		Vector v = p.pdp.showCache ( );
		for ( int i = 0; i < v.size ( ); i++ )
		{
			ServiceEntry se = ( ServiceEntry ) v.elementAt ( i );
			String de = se.getPDPService ( ).getDescription ( );
			int tm = se.getLifetime ( );
			cache.add ( tm + " @ " + de );
		}
	}

	/**
	 * This method initializes list
	 * 
	 * @return java.awt.List
	 */
	private List getResponse ( )
	{
		if ( response == null )
		{
			response = new List ( );
			response.setBounds ( 15, 105, 210, 65 );
		}
		return response;
	}

	/**
	 * This method initializes list1
	 * 
	 * @return java.awt.List
	 */
	private List getCache ( )
	{
		if ( cache == null )
		{
			cache = new List ( );
			cache.setBounds ( 15, 190, 210, 65 );
		}
		return cache;
	}

	/**
	 * This method initializes button
	 * 
	 * @return java.awt.Button
	 */
	private Button getStop ( )
	{
		if ( stop == null )
		{
			stop = new Button ( );
			stop.setBounds ( 160, 65, 45, 13 );
			stop.setLabel ( "Stop" );
			stop.setEnabled ( false );
			stop.addActionListener ( new java.awt.event.ActionListener ( ) {
				public void actionPerformed ( java.awt.event.ActionEvent e )
				{
					stop ( );
				}
			} );
		}
		return stop;
	}

	/**
	 * This method initializes button1
	 * 
	 * @return java.awt.Button
	 */
	private Button getButton1 ( )
	{
		if ( button1 == null )
		{
			button1 = new Button ( );
			button1.setBounds ( 168, 180, 55, 12 );
			button1.setLabel ( "REFRESH" );

			button1.addActionListener ( new java.awt.event.ActionListener ( ) {
				public void actionPerformed ( java.awt.event.ActionEvent e )
				{
					refreshCache ( );
				}
			} );
		}
		return button1;
	}

	/**
	 * This method initializes button2
	 * 
	 * @return java.awt.Button
	 */
	private Button getClear ( )
	{
		if ( clear == null )
		{
			clear = new Button ( );
			clear.setBounds ( 110, 65, 45, 13 );
			clear.setLabel ( "Clear" );
			clear.addActionListener ( new java.awt.event.ActionListener ( ) {
				public void actionPerformed ( java.awt.event.ActionEvent e )
				{
					reset ( );
				}
			} );
		}
		return clear;
	}

	/**
	 * This method initializes button3
	 * 
	 * @return java.awt.Button
	 */
	private Button getAccept ( )
	{
		if ( accept == null )
		{
			accept = new Button ( );
			accept.setBounds ( 60, 65, 45, 13 );
			accept.setLabel ( "Search" );
			accept.addActionListener ( new java.awt.event.ActionListener ( ) {
				public void actionPerformed ( java.awt.event.ActionEvent e )
				{
					search ( );
				}
			} );
		}
		return accept;
	}

	/**
	 * This method initializes button
	 * 
	 * @return java.awt.Button
	 */
	private Button getButton ( )
	{
		if ( button == null )
		{
			button = new Button ( );
			button.setLabel ( "EXIT" );
			button.setBounds ( 205, 0, 35, 12 );
			button.addActionListener ( new java.awt.event.ActionListener ( ) {
				public void actionPerformed ( java.awt.event.ActionEvent e )
				{
					p.close ( );
				}
			} );
		}
		return button;
	}

	public static void main ( String [] args )
	{
		Frame f = new Frame ( );
		f.setSize ( 250, 300 );
		f.add ( new SearchServices ( null ) );
		f.setVisible ( true );
	}

	/**
	 * This is the default constructor
	 */
	public SearchServices ( PDPClient p )
	{
		super ( );
		this.p = p;
		initialize ( );
		reset ( );
		refreshCache ( );
        disconnected ( );
        new NetworkSniffer ( this );
	}

	/**
	 * This method initializes this
	 * 
	 * @return void
	 */
	private void initialize ( )
	{
		this.setFont ( new Font ( "", Font.PLAIN, 10 ) );
		this.setLayout ( null );
		this.setSize ( 240, 270 );

		this.add ( getResponse ( ), null );
		this.add ( getCache ( ), null );

		Label l0 = new Label ( );
		Label l1 = new Label ( );
		Label l2 = new Label ( );
		Label l3 = new Label ( );
		Label l4 = new Label ( );
		Label status = new Label ( );

		status.setText ( "Pervasive Discovery Protocol. 2005 (c)" );
		status.setLocation ( 0, 255 );
		status.setSize ( 240, 15 );
		this.add ( status, null );

		l0.setBounds ( 5, 5, 95, 15 );
		l0.setText ( "Search Services" );
		l0.setFont ( new Font ( "", Font.BOLD, 12 ) );
		this.add ( getStop ( ), null );
		this.add ( getButton1 ( ), null );
		this.add ( getClear ( ), null );
		this.add ( getAccept ( ), null );
		this.add ( l0, null );

		l1.setText ( "Service type" );
		this.add ( l1, null );

		l2.setText ( "Request all available services" );
		this.add ( l2, null );

		l3.setBounds ( 15, 90, 50, 15 );
		l3.setText ( "Response" );
		this.add ( l3, null );

		l4.setBounds ( 15, 175, 35, 15 );
		l4.setText ( "Cache" );
		this.add ( l4, null );

		type = new TextField ( );
		this.add ( type, null );

		any = new Checkbox ( );
		l1.setSize ( 63, 15 );
		l1.setLocation ( 40, 25 );
		l2.setSize ( 148, 15 );
		l2.setLocation ( 40, 45 );
		type.setBounds ( 105, 25, 99, 16 );
		any.setBounds ( 191, 46, 14, 14 );
		this.add ( any, null );
		this.add ( getButton ( ), null );

		led = new Label ( );
		led.setBounds ( 193, 0, 12, 12 );
		connected ( );
		this.add ( led, null );
	}

	protected void connected ( )
	{
		led.setBackground ( Color.green );
		accept.setEnabled ( ac );
		clear.setEnabled ( cl );
		stop.setEnabled ( st );
	}

	protected void disconnected ( )
	{
		led.setBackground ( Color.red );
        ac = accept.isEnabled();
        cl = clear.isEnabled();
        st = stop.isEnabled();
		accept.setEnabled ( false );
		clear.setEnabled ( false );
		stop.setEnabled ( false );
	}
} //  @jve:decl-index=0:visual-constraint="162,9"

class SearchBG extends Thread
{
	SearchServices	ss;
	String			stype;
	boolean			b;

	SearchBG ( SearchServices ss, String stype, boolean b )
	{
		this.ss = ss;
		this.stype = stype;
		this.b = b;
        this.start ( );
	}

	public void run ( )
	{
		Vector v = null;
		try
		{
			Object lock = ss.p.pdp.searchService ( stype, !b );

			synchronized ( lock )
			{
				lock.wait ( );
			}
			v = ss.p.pdp.getResponse ( );
		}
		catch ( Exception e )
		{
			v = null;
		}
        ss.addResponse ( v );
	}
}